function [channelgains_matrix]=Rice(BS,User,ns)
% generate the channel gain between each User-BS pair over the subband,suppose there are M blocks

global N; %number of users
global K; %number of CAPs
global M;%number of CAPs in a group
global L;% numbers of power levels
global Ts;% time of one offlaoding round
global Ttr;% time of one transmit frame

global K_cpu; % CPU factor
global P_max
global W_sub;% bandwidth
global N_0;% noise
global Lambda1
global Lambda2
global rou
global alpha
global num_slot
global weighE
global weighF

N=length(User);
K=length(BS);

channelgains_matrix=zeros(N,K,ns);
Distance1=zeros(N,K);



for i=1:N
    for j=1:K     %  
        Distance1(i,j)=sqrt((User(i).X-BS(j).X)^2+(User(i).Y-BS(j).Y)^2); %UE i BS j֮ľ
        
    end
end
l=Distance1.^(3.5);% path loss

fastfading=zeros(N,K,ns); % frequency selective fading


% for m=1:M   % ΪÿһʺͶӦŵ
% for i=1:U
%     for j=1:S
%    
%     fastfading(m,i,j,:)=Fast_Fading('rayleigh',N); % Ӧŵ ,λDB
%     fastfading(m,i,j,:)=10.^(fastfading(m,i,j,:)./10);%תɱ
%     end
% end
% end
for m=1:ns  % ΪÿһʺͶӦŵ
for i=1:N
    for j=1:K
    
    han=ricianchan(1,0,10^(0.6)); % Ӧŵ ,λDB
  %  han=rayleighchan(1,0,10^(0.6)); % Ӧŵ ,λDB 
    fastfading(i,j,m)=real(han.PathGains);
    fastfading(i,j,m)=10.^(fastfading(i,j,m)./10);%תɱ
    
    end
end
end
for m=1:ns 
    for i=1:N
        for j=1:K          
   channelgains_matrix(i,j,m)=l(i,j).*fastfading(i,j,m);
        end
     end
end

